
var fgDebug = false;

var messages = srGetStrBundle("chrome://foxgame/locale/foxgame.properties");

function addJavaScript(doc, js) {
    
  var head = doc.getElementsByTagName("head")[0];    

  var script = doc.createElement("script");
  script.setAttribute("language", "JavaScript");
  script.setAttribute("src", js);
  head.appendChild(script);
  
  return script;
    
}

function addFiring(doc, func) {

  var head = doc.getElementsByTagName("head")[0];    

  var script = doc.createElement("script");
  script.setAttribute("language", "JavaScript");
  script.innerHTML = 'function fire(){'+
	'window.removeEventListener("mousemove", fire, true);'+
	func+'();'+
	'}'+
	'window.addEventListener("mousemove", fire, true);';
  head.appendChild(script);


}

function fgEvalnode(path,document,node) {
	var ret = document.evaluate(path,node,null,
			XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (fgDebug) alert(ret.snapshotLength);

	return ret;

}

function fgEval(path,document) {
	return fgEvalnode(path,document,document);
}

function isOGameDomain(href) {

    if (href.match(/^file:\/\//) && fgDebug) return true;
          
     var sites = new Array(/^http:\/\/(.*\.)?ogame\d*\.de/i,
				/^http:\/\/s\d+\.gfsrv\.net/i,
				/^http:\/\/213\.239\.220\.37/i,
				/^http:\/\/213\.239\.213\.168/i,
				/^http:\/\/213\.239\.213\.169/i,
				/^http:\/\/213\.239\.215\.75/i,
				/^http:\/\/213\.239\.217\.140/i,
				/^http:\/\/game1009\.de/i,
				/^http:\/\/.*\.ogamed*\.de\.es/i,
				/^http:\/\/(.*\.)?ogame\.com\.es/i,
				/^http:\/\/(.*\.)?ogame\.de/i,
				/^http:\/\/(.*\.)?ogame\.fr/i,
				/^http:\/\/(.*\.)?ogame\.pl/i,
				/^http:\/\/(.*\.)?ogame\.nl/i,
				/^http:\/\/(.*\.)?ogame\.dk/i,
				/^http:\/\/(.*\.)?ogame\.it/i,
				/^http:\/\/(.*\.)?ogame\.ru/i,
				/^http:\/\/(.*\.)?ogame\.sk/i,
				/^http:\/\/(.*\.)?ogame\.ba/i,
				/^http:\/\/(.*\.)?ogame\.com\.hr/i,
				/^http:\/\/(.*\.)?ogame\.com\.tw/i,
				/^http:\/\/(.*\.)?ogame\.com\.br/i,
				/^http:\/\/(.*\.)?ogame\.com\.pt/i,
				/^http:\/\/(.*\.)?ogame\.com\.tr/i,
				/^http:\/\/(.*\.)?ogame\.org/i);
            
     for (var i = 0; i< sites.length; i++) {
        if (href.search(sites[i]) > -1) {
          return true;   
        } 
     }    
     return false;
}

function adjustPagesfg(event)	{
    
       var doc = event.originalTarget;
       
       try {
           if (doc.nodeType != doc.DOCUMENT_NODE) 
                doc = doc.ownerDocument;
		
		var href = doc.location.href;     
		if (isOGameDomain(href)) {
			var functions = new Array(
				selectUniverse,
				addFlotaTime,
				addFlotaReturnTime,
				addMilosButtons,
				//addKeyNavigation,
				addDebrisImage,
				removePlanets,
				//addPlanetTooltips,
				colorizePrivates,
				colorizeAlly,
				addBuildingsTime,
				addResearchTime,
				addOverviewTime,
				addBuildingTime,
				replicateDeleteOptions
			);
			callOgameFunctions(functions, doc);
		}
	} catch (e) {
		foxgameDebug(e);
	}

}

function callOgameFunction(func, doc) {
    try {
        func(doc);   
    } catch (e) {
        foxgamedebug(e);
    }
}

function callOgameFunctions(funcs, doc) {
    
    for (var i=0; i<funcs.length; i++) {
        callOgameFunction(funcs[i], doc);
    }
    
}

function foxgame_initPopupMenu(event) {
    try {    
    	if (event.target.id != "contentAreaContextMenu") return;

//	gContextMenu.showItem("foxgame-config-menu",isOGameDomain(window._content.document.location.href));
   	var fgMenu = document.getElementById("foxgame-config-menu");
//	dump(isOGameDomain(window._content.document.location.href)+"\n");
	fgMenu.setAttribute("hidden",!isOGameDomain(window._content.document.location.href));
//	fgMenu.setAttribute("collapsed",!isOGameDomain(window._content.document.location.href));
//	fgMenu.hidden = !isOGameDomain(window._content.document.location.href);
//	fgMenu.collapsed = !isOGameDomain(window._content.document.location.href);
//	dump(fgMenu.hidden+"\n");
	return;
    } catch (e){
        foxgamedebug(e);
    }

}

function isLoginUrl(href) {
    return href.search(/portal\//i) > -1;
}

function isFlota2Url(href) {
	return href.search(/flotten2\.php/i) > -1;
}

function isFlotaUrl(href) {
	return href.search(/flotten1\.php/i) > -1;
}

function isGalaxyUrl(href) {
	return href.search(/galaxy\.php/i) > -1;
}

function isMessagesUrl(href) {
	return href.search(/\/messages\.php/i) > -1;
}

function isBuildingsUrl(href) {
	return href.search(/\/buildings\.php/i) > -1;
}

function isBuildings2Url(href) {
	return href.search(/\/b_building\.php/i) > -1;
}

function isOverviewUrl(href) {
	return href.search(/\/overview\.php/i) > -1;
}


function selectUniverse(doc) {

	if (doc && !isLoginUrl(doc.location.href)) return;
	if (!fgGetBooleanPref("foxgameSelectUniverse",true)) return;

	try {
		if (doc.location.href.indexOf(PrefsBranchFG.getCharPref("fgServer")) == -1) return;
	} catch(e){ return;}

	if (fgDebug) alert("Estamos Universo");

	try {
		var uni = PrefsBranchFG.getCharPref("fgUni");
	} catch(e) { return;}
	var univeroption = doc.evaluate( 
		'//option[@value="'+uni+'"]', doc, null, 					
		XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	if (univeroption.snapshotLength == 0) return;

	univeroption.snapshotItem(0).selected = true;
}

function fgFindParentDocument(document) {
	try {
		var l = gBrowser.mPanelContainer.childNodes.length;
		var found = false;
		for(var i = 0; i < l; i++) {
			var b = gBrowser.getBrowserAtIndex(i);
			if (isOGameDomain(b.currentURI.spec)) 
			{
				var frames = b.contentDocument.getElementsByTagName("frame");
				if(frames.length > 1 && (frames[1].contentDocument == document))
				{
					return b.contentDocument;
				}
			}
		}
		return null;
	} catch(e){
		foxgamedebug(e);
		return null;
	}	
}

function addBuildingTime(document) {

	if (document && !isBuildingsUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameBuildingTime",true)) return;

	if (fgDebug) alert("Estamos tiempo hangar");

	try {
	      var path = '//form/form';
      	var obj = fgEval(path,document);

		if (obj.snapshotLength == 0) return;

		obj = obj.snapshotItem(0);
		var text = obj.nextSibling.nodeValue;
		text = text.split(':');
		text = text[1].trim();
		text = text.split(' ');
		var sec = 0, temp = 0;
		for (var i = 0; i < text.length; i++) {
			text[i]=text[i].replace(/^\s0(.*)/, "$1");
			temp = parseInt(text[i]);
			if (text[i+1] == 'd')
				sec = sec + (temp * 86400);
			else if (text[i+1] == 'h')
				sec = sec + (temp * 3600);
			else if (text[i+1] == 'm')
				sec = sec + (temp * 60);
			else if (text[i+1] == 's')
				sec = sec + temp;
			i++;
		}
		var date = new Date();
		date.setTime(date.getTime() + (sec*1000));
		var date2 = new Date();
		var text2;
		if (date.getDate() != date2.getDate())
			text2 = document.createTextNode(messages.GetStringFromName("foxgame.inner.finishTime") + " : " + formatDate(date,"d/MM H:mm:ss"));
		else
			text2 = document.createTextNode(messages.GetStringFromName("foxgame.inner.finishTime") + " : " + formatDate(date,"H:mm:ss"));
		br = document.createElement("br");
		obj.parentNode.appendChild(br);
		obj.parentNode.appendChild(text2);
		
	} catch (e) {
		foxgamedebug(e);
	}
}

function addResearchTime(document) {

	if (document && !isBuildingsUrl(document.location.href))  return;
	if (!fgGetBooleanPref("foxgameResearchTime",true)) return; 
	
	if (fgDebug) alert("Estamos tiempo investigacion");

	setTimeout(function(){
		fg_addBxxTime(document);
	},200);
}

function addBuildingsTime(document) {

	if (document && !isBuildings2Url(document.location.href))  return;
	if (!fgGetBooleanPref("foxgameBuildingsTime",true)) return; 
	
	if (fgDebug) alert("Estamos tiempo construccion");

	fg_addBxxTime(document);
}

function fg_addBxxTime(document) {

	try {
	      var path = '//div[starts-with(@id,"bxx")]';
      	var obj = fgEval(path,document);


		var date, date2 = new Date();
		var secs;
		var ele;
		var text;
		for (var i = 0; i < obj.snapshotLength; i++) {
			ele = obj.snapshotItem(i);
			text = ele.firstChild.nodeValue.split(':');
			secs = parseInt(text[0].replace(/^\s0(.*)/, "$1")) * 3600;
			secs = secs + parseInt(text[1].replace(/^\s0(.*)/, "$1")) * 60;
			secs = secs + parseInt(text[2].replace(/^\s0(.*)/, "$1"));

			date = new Date();
			date.setTime(date.getTime() + (secs*1000));

			var text2;
			if (date.getDate() != date2.getDate())
				text2 = document.createTextNode(formatDate(date,"d/MM H:mm:ss"));
			else
				text2 = document.createTextNode(formatDate(date,"H:mm:ss"));
			var font = document.createElement("strong");
			font.innerHTML = "<br /><font color='lime'>" +text2.nodeValue+"</font>";
			font.setAttribute("color","lime");
			//font.appendChild(text2);
			ele.parentNode.appendChild(font);
		}

	} catch (e) {
		setTimeout(function(){
			fg_addBxxTime(document);
		},100);
	}

}

function addOverviewTime(document) {

	if (document && !isOverviewUrl(document.location.href)) return;
	
	if (fgDebug) alert("Estamos tiempo vision");

	try {
	      var path = '//div[starts-with(@id,"bxx")]';
      	var obj = fgEval(path,document);


		var date, date2 = new Date();
		var secs;
		var ele;
		for (var i = 0; i < obj.snapshotLength; i++) {
			ele = obj.snapshotItem(i);
			secs = parseInt(ele.getAttribute("title"));
			date = new Date();
			date.setTime(date.getTime() + (secs*1000));

			var text2;
			if (date.getDate() != date2.getDate())
				text2 = document.createTextNode(formatDate(date,"d/MM H:mm:ss"));
			else
				text2 = document.createTextNode(formatDate(date,"H:mm:ss"));
			var font = document.createElement("font");
			font.setAttribute("color","lime");
			font.appendChild(text2);
			if (fgGetBooleanPref("foxgameAddOverviewTime",false)) 
				ele.parentNode.appendChild(font);
			if (fgGetBooleanPref("foxgameRemoveOverviewTime",true))
				ele.parentNode.removeChild(ele);
		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function removeOverviewTime(document) {

	if (document && !isOverviewUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameRemoveOverviewTime",true)) return;

	if (fgDebug) alert("Estamos tiempo vision2");

	try {
	      var path = '//div[starts-with(@id,"bxx")]';
      	var obj = fgEval(path,document);


		for (var i = 0; i < obj.snapshotLength; i++) {
			ele = obj.snapshotItem(i);
			ele.parentNode.removeChild(ele);
		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function addKeyNavigation(document) {

	if (document && !isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameKeyNavigation",true)) return;

	
	if (fgDebug) alert("Estamos teclado");

	//Insertamos el .js con la funcion de navegacion por teclado
	addJavaScript(document, "chrome://foxgame/content/resources/js/keyGalaxy.js");

}

function addDebrisImage(document) {

	if (document && !isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameHighlightDebris",true)) return;	

	if (fgDebug) alert("Estamos escombros");

	try {

	      var path = '//table[@width="569"]/child::tbody/descendant::tr/child::th[1]/child::a[2]';
      	var obj = fgEval(path,document);

		try {
			var color = PrefsBranchFG.getCharPref("fgDebrisColor");
		} catch(e) { var color ="#AA3333";}

		try {
			var min = PrefsBranchFG.getCharPref("fgDebrisMin");
		} catch(e) { var color ="20000";}

		min = parseInt(min.replace(/[\.,]/i,''));

		var title, metal, cristal;
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj2 = obj.snapshotItem(i);
			title = obj2.getAttribute("title");
			title = title.split(':');
			metal = title[2].split(',');
			metal = metal[0].replace(/[\s\.]/gi,'');
			cristal = title[3].replace(/[\s\.]/gi,'');

			if (parseInt(metal) + parseInt(cristal) >= min) {
				obj2.parentNode.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.setAttribute("style", "background-color : "+color+";");
			}	
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

function removePlanets(document) {
	
	if (document && !isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameRemovePlanets",true)) return;
	
	if (fgDebug) alert("Estamos planets");
	

	try {
	      var path = '//table[@width="569"]/child::tbody/child::tr/child::th[position()=2]';
      	var obj = fgEval(path,document);		
	
		if (obj.snapshotLength == 0) return;

		var text;
		for (var i = 0; i < obj.snapshotLength; i++) {
			if (obj.snapshotItem(i).firstChild.nextSibling != null) {
				text = obj.snapshotItem(i).nextSibling.nextSibling.innerHTML;			
				obj.snapshotItem(i).nextSibling.nextSibling.innerHTML = "";
				obj.snapshotItem(i).nextSibling.nextSibling.appendChild(
					obj.snapshotItem(i).removeChild(obj.snapshotItem(i).firstChild.nextSibling));
				obj.snapshotItem(i).nextSibling.nextSibling.firstChild.innerHTML = text;
			}
			
			obj.snapshotItem(i).parentNode.removeChild(obj.snapshotItem(i));
		}

	      path = '//table[@width="569"]/descendant::td[@class="c"][position()=2]';
      	obj = fgEval(path,document);		
		
		for (var i = 0; i < obj.snapshotLength; i++) {
			if (i == 0) {
				text = obj.snapshotItem(i).innerHTML;
				obj.snapshotItem(i).nextSibling.nextSibling.innerHTML = text;
			}
			obj.snapshotItem(i).parentNode.removeChild(obj.snapshotItem(i));
		}

	      path = '//table[@width="569"]/descendant::td[@class="c"][position()=5]';
      	obj = fgEval(path,document);
		obj.snapshotItem(0).innerHTML = messages.GetStringFromName("foxgame.inner.reducedDebris");
		

	      path = '//table[@width="569"]/descendant::td[@class="c"][@colspan="8"]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj.snapshotItem(i).setAttribute("colspan","7");
		}
	      path = '//table[@width="569"]/descendant::td[@class="c"][@colspan="6"]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj.snapshotItem(i).setAttribute("colspan","5");
		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function colorizePrivates(document) {

	if (document && !isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameColorizePrivates",true)) return;

	
	if (fgDebug) alert("Estamos privados");
	
	try {

		var path = '//table/tbody/tr/th[4]/child::a/img[@alt!=""]';
		var obj = fgEval(path,document);
		try {
			var color = PrefsBranchFG.getCharPref("fgPrivateColor");
		} catch(e) { var color ="#AA3333";}

		for (var i = 0; i < obj.snapshotLength; i++)
		{	
				
			obj2 = obj.snapshotItem(i).parentNode.parentNode.parentNode;
			var nodes = obj2.childNodes;			
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+";");
			}
			nodes = obj2.nextSibling.nextSibling.childNodes;
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+";");
			}

		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function colorizeAlly(document) {

	if (document && !isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameHighlightAllyMessages",true)) return;

	
	if (fgDebug) alert("Estamos alianza");
	
	try {

		var path = '//table/tbody/tr/th[3]';
		var obj = fgEval(path,document);
		try {
			var color = PrefsBranchFG.getCharPref("fgAllyColor");
		} catch(e) { var color ="#AA3333";}

		for (var i = 0; i < obj.snapshotLength; i++)
		{		
			var subject = obj.snapshotItem(i).innerHTML;
			if (!subject.match(/\s\[.*\]\s$/)) continue;
			obj2 = obj.snapshotItem(i).parentNode;
			var nodes = obj2.childNodes;			
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+";");
			}
			nodes = obj2.nextSibling.nextSibling.childNodes;
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+";");
			}

		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function replicateDeleteOptions(document) {

	if (document && !isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameReplicateDeleteOptions",true)) return;

	
	if (fgDebug) alert("Estamos opciones de borrado");
	
	try {
		var path = '//table/tbody/tr/th/select[@name="deletemessages"]';
		var row = fgEval(path,document);
		if (row.snapshotLength == 0) return;
		row = row.snapshotItem(0).parentNode.parentNode;
		var row2 = row.cloneNode(true);
		row.firstChild.nextSibling.firstChild.nextSibling.setAttribute("id","deletemessages");
		row.firstChild.nextSibling.firstChild.nextSibling.setAttribute("onchange","document.getElementById('deletemessages2').options[this.selectedIndex].selected='true'");

		row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("name","deletemessages2");
		row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("id","deletemessages2");
		row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("onchange","document.getElementById('deletemessages').options[this.selectedIndex].selected='true'");
		row.parentNode.insertBefore(row2,row.parentNode.firstChild);
		
		//Recolocamos el formulario para que el arbol tenga una estructura correcta
	
		var table = fgEval( 
			'//input[@name="messages"]', document)
		if (table.snapshotLength == 0) return;
		table = table.snapshotItem(0).parentNode.parentNode.parentNode.parentNode;
		var form = fgEval (
			'//form[starts-with(@action,"messages")]', document).snapshotItem(0);
		if (form.snapshotLength == 0) return;
		form = form.parentNode.removeChild(form);

		table.parentNode.replaceChild(form,table);
		form.appendChild(table);

	} catch (e) {
		foxgamedebug(e);
	}
}

String.prototype.trim = function() {

 // skip leading and trailing whitespace
 // and return everything in between
  var x=this;
  x=x.replace(/^\s*(.*)/, "$1");
  x=x.replace(/(.*?)\s*$/, "$1");
  return x;
}

String.prototype.retrim = function() {

 // skip leading and trailing whitespace
 // and return everything in between
  var x=this;
  x=x.replace(/^\s*(.*)/, "$1");
  x=x.replace(/(.*)\s*(.*)/g, "$1 $2");
  x=x.replace(/(.*?)\s*$/, "$1");
  return x;
}

function addMilosButtons(document) {

	if (document && !isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddMilosButtons",false)) return;

	
	if (fgDebug) alert("Estamos milos");
	
	try {
//Insertamos el .js con la funcion de envio del formulario

		addJavaScript(document, "chrome://foxgame/content/resources/js/milosGalaxy.js");


// Generamos un formulario para enviar la galaxia a MILOS directamente

      var path = '//table[@width="569"]';
      var obj = fgEval(path,document);

	if (obj.snapshotLength == 0) return;

	obj = obj.snapshotItem(0);
	var tr = obj.firstChild.nextSibling.firstChild;
	var text = "";
      var range = document.createRange();

	while (tr != null)
 	{
		if (tr.nodeName == 'TR') {
			td = tr.firstChild;
			while (td != null) {
				if (td.nodeName == 'TD' || td.nodeName == 'TH')
				{
						var a = fgEvalnode('.//img[contains(@alt,"M")]',document,td);
						if (a.snapshotLength > 0) 
						{
							text += "M \t";
						}
						else {
						      range.selectNode(td);
							text += range.toString().retrim()+" \t";
						}
				}
				td = td.nextSibling;
			}
			text = text.substr(0,text.length-2)+"\n";
		}
		tr = tr.nextSibling;
	}
	range.detach;
	texto = text;


		//Insertamos un formulario para poder enviar los datos directamente.	

		var form = document.createElement('tr');
		var td = document.createElement('td');
		td.setAttribute("colspan","8");
		td.setAttribute("class","1");
		td.setAttribute("align","center");
		td.setAttribute("valign","middle");
		td.innerHTML = 
		"<div style=\"position:absolute; z-index:1; top:100px; left:50px; visibility: hidden\" id=\"div_frame\">"+
		'<table celspacing="0" celpadding="0"><tr><td align="right"><a onclick="hide()">'+messages.GetStringFromName("foxgame.inner.close") +'</a></td></tr><tr><td>'+
		"<iframe src=\"\" name=\"_milos\"id=\"_milos\" height=\"300\" width=\"600\"></iframe>"+
		'</td></tr></table></div>'+
		'<form action="http://milos.nethen.org/milos-paste/#" method=post target="_milos" id="milos_form">'+
		'<input type=hidden name="show" value="">'+
		'<input type=hidden name="noncommit" value="">'+
		'<input type=hidden name="delafter" value="checked">'+
		'<input type=hidden name=x value="'+texto+'">'+
		//'<textarea name=x rows=1 cols=75>'+texto+'</textarea>'+
		"<input type=button value=\""+messages.GetStringFromName("foxgame.inner.milos&prev")+"\" onClick=\"next('l')\">"+
		"<input type=button value=\""+messages.GetStringFromName("foxgame.inner.milos")+"\" onClick=\"next('1')\">"+
		"<input type=button value=\""+messages.GetStringFromName("foxgame.inner.milos&next")+"\" onClick=\"next('r')\">";
		
		form.appendChild(td);

		var tds = fgEval( 
			'//table[@width="569"]/descendant::td[@colspan="2"][@class="c"][last()]', document).snapshotItem(0);
		tds.parentNode.parentNode.appendChild(form);
	

	} catch (e) {
		foxgamedebug(e);
	}
}

function addFlotaReturnTime(document) {

	if (document && !isFlotaUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaReturnTime",true)) return;

	
	if (fgDebug) alert("Estamos flota return");

	try {
		//Aadimos la hora de retorno en caso de retirada
		var date2 = new Date();
		var obj = fgEval( '//input[@name="order_return"]', document);
		for ( var i = 0; i < obj.snapshotLength; i++) {
			var date = new Date();
			var cell = obj.snapshotItem(i).parentNode.parentNode;
			var startTime = cell.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling;
			startTime = getDateFromFormat(startTime.innerHTML + " " + (1900+date.getYear()),"E MMM d H:m:s y");
			date.setTime(date.getTime() + date.getTime() - startTime);
			var font = document.createElement('font');
			font.setAttribute('color','lime');
			var div = document.createElement('div');
			div.setAttribute('id',"time_"+i);
			if (date.getDate() != date2.getDate())
				div.innerHTML = formatDate(date,"d/MM H:mm:ss");
			else
				div.innerHTML = formatDate(date,"H:mm:ss");	
			font.appendChild(div);
			cell.appendChild(font);
		}
		if (obj.snapshotLength > 0)
			setTimeout(fgadjustReturnTime,499);
	} catch (e) {
		foxgamedebug(e);
	}
};

function fgadjustReturnTime(){
	try {
		var l = gBrowser.mPanelContainer.childNodes.length;
		var found = false;
		for(var i = 0; i < l; i++) {
			var b = gBrowser.getBrowserAtIndex(i);
			if (isOGameDomain(b.currentURI.spec)) 
			{
				/*
				var frames = b.contentDocument.getElementsByTagName("frame");
				if(frames.length > 1 && isFlotaUrl(frames[1].contentDocument.location.href))
				{
					found = true;
					fgadjustReturnTime2(frames[1].contentDocument);
				}
				*/
				var ret = fg_findUrlInFrames(b.contentDocument,isFlotaUrl);
				if (ret != null) {
					found = true;
					fgadjustReturnTime2(ret);
				}
			}
		}
		if (found) {
			setTimeout(fgadjustReturnTime, 250);
		}
	} catch(e){
		foxgamedebug(e);
	}	
}

function fgadjustReturnTime2(doc){
		try {
			var document = doc;
			if (document && document.location && !isFlotaUrl(document.location.href)) return;
			var i=0;
			var obj;
			var date2 = new Date();
			obj = document.getElementById("time_"+i);
			while (obj != null) {
				var date = new Date();
				var cell = obj.parentNode.parentNode;
				var startTime = cell.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling;
				startTime = getDateFromFormat(startTime.innerHTML + " " + (1900+date.getYear()),"E MMM d H:m:s y");
				date.setTime(date.getTime() + date.getTime() - startTime);
				if (date.getDate() != date2.getDate())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");			
				i++;
				obj = document.getElementById("time_"+i);
			}
		} catch (e) {
			foxgamedebug(e);
		}
}

function fgDuration(document) {
	try {
	  	var speedfactor;

		speedfactor = document.getElementsByName("speedfactor")[0].value;
		var msp = fgMaxspeed(document);
		var sp = document.getElementsByName("speed")[0].value;
		var dist = fgDistance(document);

  		return Math.round(((35000 / sp * Math.sqrt(dist * 10 / msp) + 10) / speedfactor)); 
	} catch(e) {
		//alert("fgDuration");
		setTimeout(fgadjustTime, 100);
		return 0;
	}
}


function min(a, b) {
  a = a * 1;
  b = b * 1;
  if (a > b) {
    return b;
  } else {
    return a;
  }
}

function fgMaxspeed(document) {
	try {
		var msp = 1000000000;
		for (i = 200; i < 220; i++) {
			if (document.getElementsByName("ship" + i)[0]) {
				if ((document.getElementsByName("speed" + i)[0].value * 1) >= 1
				&& (document.getElementsByName("ship" + i)[0].value * 1) >= 1) {
					msp = min(msp, document.getElementsByName("speed" + i)[0].value);
				}
			}
		}
		return(msp);
	} catch(e) {
		//alert("fgMaxSpeed");
		setTimeout(fgadjustTime, 100);
		return 0;
	}
}

function fgDistance(document) {
	try {
  		var thisGalaxy;
  		var thisSystem;
  		var thisPlanet;

  		var targetGalaxy;
  		var targetSystem;
  		var targetPlanet;

  		var dist;

  		thisGalaxy = document.getElementsByName("thisgalaxy")[0].value;
  		thisSystem = document.getElementsByName("thissystem")[0].value;
  		thisPlanet = document.getElementsByName("thisplanet")[0].value;

  		targetGalaxy = document.getElementsByName("galaxy")[0].value;
  		targetSystem = document.getElementsByName("system")[0].value;
  		targetPlanet = document.getElementsByName("planet")[0].value;

  		dist = 0;
  		if ((targetGalaxy - thisGalaxy) != 0) {
  			dist = Math.abs(targetGalaxy - thisGalaxy) * 20000;
  		} else if ((targetSystem - thisSystem) != 0) {
    			dist = Math.abs(targetSystem - thisSystem) * 5 * 19 + 2700;
  		} else if ((targetPlanet - thisPlanet) != 0) {
    			dist = Math.abs(targetPlanet - thisPlanet) * 5 + 1000;
  		} else { 
    			dist = 5;
  		}

  		return(dist);
	} catch(e) {
		//alert("fgDistance");
		setTimeout(fgadjustTime, 100);
		return 0;
	}
}

function fg_findUrlInFrames(document,func) {

	var frames = document.getElementsByTagName("frame");
	for (var i = 0; i < frames.length; i++) {
		if (func(frames[i].contentDocument.location.href)) {
			return(frames[i].contentDocument);
		}
		var ret = fg_findUrlInFrames(frames[i].contentDocument,func);
		if (ret != null)
			return ret;
	}	
	return null;
}

function fgadjustTime(){
	try {
		var l = gBrowser.mPanelContainer.childNodes.length;
		var found = false;
		for(var i = 0; i < l; i++) {
			var b = gBrowser.getBrowserAtIndex(i);
			if (isOGameDomain(b.currentURI.spec)) 
			{
				/*
				var frames = b.contentDocument.getElementsByTagName("frame");
				if(frames.length > 1 && isFlota2Url(frames[1].contentDocument.location.href))
				{
					found = true;
					fgadjustTime2(frames[1].contentDocument);
				}else{
						alert("no frame with mathcing url");
				}
				*/
				var ret = fg_findUrlInFrames(b.contentDocument,isFlota2Url);
				if (ret != null) {
					found = true;
					fgadjustTime2(ret);
				}	
			}
		}
		if (found) {
			setTimeout(fgadjustTime, 250);
		}
	} catch(e){
		foxgamedebug(e);
	}	
}

function fgadjustTime2(doc){
		try {
			var document = doc;
			var date = new Date();
			var date2 = new Date();
			obj = document.getElementById("llegada1");
			if (obj != null) 
			{
				var duration = fgDuration(document);
				date.setTime(date.getTime() + (duration*1000))
				if (date.getDate() != date2.getDate())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");	
				date.setTime(date.getTime() + (duration*1000))
			}
			obj = document.getElementById("llegada2");
			if (obj != null) 
			{	
				if (date.getDate() != date2.getDate())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");	
			}
		} catch (e) {
			foxgamedebug(e);
		}
}

function addFlotaTime(document) {

	if (document && !isFlota2Url(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaTime",true)) return;

	
	if (fgDebug) alert("Estamos");

	try {


		// Mostramos la hora de retorno y llegada de las naves

		//Insertamos las filas necesarias en la tabla

		var node = document.getElementById("duration");

		if (node == null) return;

		node = node.parentNode.parentNode;
		var tr2 = document.createElement('tr');
		tr2.setAttribute("height","20");
		var th2 = new Array(document.createElement('th'),document.createElement('th'));
		th2[0].innerHTML = messages.GetStringFromName("foxgame.inner.arrival2");
		th2[1].innerHTML = "<div id=\"llegada2\">-</div>";

		for (var i=0; i<th2.length; i++)
			tr2.appendChild(th2[i]);

		node.parentNode.insertBefore(tr2,node.nextSibling);
		var tr = document.createElement('tr');
		tr.setAttribute("height","20");
		var th = new Array(document.createElement('th'),document.createElement('th'));
		th[0].innerHTML = messages.GetStringFromName("foxgame.inner.arrival1");
		th[1].innerHTML = "<div id=\"llegada1\">-</div>";
	
		for (var i=0; i<th.length; i++)
			tr.appendChild(th[i]);

		node.parentNode.insertBefore(tr,node.nextSibling);
	

		//Recolocamos el formulario para que el arbol tenga una estructura correcta
	
		var table = fgEval( 
			'//table[@border="0"][@cellpadding="0"][@cellspacing="1"][@width="519"]', document).snapshotItem(0);
		var form = table.firstChild.nextSibling;
		form = table.removeChild(form);

		var input = fgEval( 
			'//input[@name="thisgalaxy"]', document).snapshotItem(0);
		var center = input.parentNode;
		center.parentNode.replaceChild(form,center);
		form.appendChild(center);

		//Llamamos a la funcion que actualiza el tiempo
		fgadjustTime();
	} catch (e) {
		foxgamedebug(e);
	}
}

window.addEventListener('DOMContentLoaded', adjustPagesfg, true);
window.addEventListener("popupshowing", foxgame_initPopupMenu, true);